﻿Module CommonCheckSystem

    ' Общие параметры
    Public PingInterval As Integer
    Public CheckInterval As Integer
    Public TimeBetweenPings As UShort
    Public AppCloseTime As Integer
    ' Поток общей проверки
    Private CheckSystemThread As Thread

    Private Sub CheckSystemThreadProc()
        On Error GoTo ErrorHandler
        Dim CheckTmr As Integer
        Do While True
            If My.Computer.Clock.TickCount >= CheckTmr Then
                CheckWindows()
                CheckTmr = My.Computer.Clock.TickCount + CheckInterval
            End If
            Thread.Sleep(ThreadSleepInterval)
        Loop
ErrorHandler:
        HandleCrash(Err, Err.GetException, "Сбой в CommonCheckSystem")
    End Sub

    Public Sub CheckSystemStart()
        If Not IsNothing(CheckSystemThread) Then Return
        CheckSystemThread = New Thread(AddressOf CheckSystemThreadProc)
        CheckSystemThread.Start()
    End Sub

    Public Sub CheckSystemStop()
        If Not IsNothing(CheckSystemThread) Then CheckSystemThread.Abort()
        CheckSystemThread = Nothing
    End Sub

    Private Sub CheckWindows()
        Dim WinHandle As Integer
        For Each ErrWnd As String In ErrWindows
            WinHandle = FindWindow(vbNullString, ErrWnd)
            If WinHandle <> 0 Then
                OutLog(NewCData("Обнаружено окно: " & ErrWnd, cfontWarning), TimeStamp)
                PostMessage(WinHandle, WM_CLOSE, 0, 0)
            End If
        Next
    End Sub

End Module
