Option Strict Off
Option Explicit On
Module Main

    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
    Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Integer, ByVal Msg As UShort, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    Public Declare Function ShowWindow Lib "user32" (ByVal hWnd As Integer, ByVal nCmdShow As Short) As Integer
    Public Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hWnd As Integer, ByVal Text As String) As Integer
    Public Declare Sub memcpy_uint_int Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Integer, ByRef Source As UInteger, ByVal Length As Integer)
    Public Const WM_CLOSE As UShort = 16

    Public Const SupportAddress As String = "http://mangos.ru/showthread.php?t=13871"

    Public VersionString As String = My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Build

    Public MainWindow As frmMain

    Public Apps() As CApplication = {}

    Public ErrWindows() As String = {}
    Public LogStrings() As String = {}

    Public Const ThreadSleepInterval As Integer = 100
    Public Const ThreadWaitInterval As Integer = 20

    Public Sub Wait(ByVal Mil As Integer)
        Dim Tmr As Integer
        Tmr = My.Computer.Clock.TickCount + Mil
        Do
            My.Application.DoEvents()
        Loop While My.Computer.Clock.TickCount < Tmr
    End Sub

    Public Sub ShutdownAll(ByVal Confirm As Boolean, Optional ByVal Quit As Boolean = True, Optional ByVal SaveGUIConfig As Boolean = True)
        If Confirm Then If MsgBoxResult.No = MsgBox("       MangoRestart?", MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo) Then Exit Sub
        If Quit Then CommandSystemStop()
        ShowWindows()
        CheckSystemStop()
        ShutdownServers()
        If SaveGUIConfig Then SaveUserData()
        If Quit Then
            MainWindow.Dispose()
            End
        End If
    End Sub

    Public Sub InitThreads()
        CheckSystemStart()
        For Each objApp As CApplication In Apps
            objApp.ThreadStart()
        Next
    End Sub

    Public Sub InitGlobals()
        '  
        Array.Resize(Apps, 0)
        Array.Resize(LogStrings, 0)
        Array.Resize(ErrWindows, 0)
        ' 
        ServerCrashedSound = ""
        ServerStartedSound = ""
        ServerStartFailedSound = ""
        MangoRestartCrashedSound = ""
        ChatSound = ""
        ' Balloons
        EnableBalloons = False
        BalloonsTimeOut = 0
        ' 
        PingInterval = 20000
        CheckInterval = 2000
        TimeBetweenPings = 1000
        AppCloseTime = 5000
    End Sub

End Module